{-# LANGUAGE TypeOperators,
             MultiParamTypeClasses,
             FlexibleContexts
 #-}

module AOP.Internal.AOPMonad (
AOPMonad(..),
MonadDeploy(..)
) where

import AOP.Internal.Aspect
import AOP.Internal.LessGen
import AOP.Internal.Typeable1Monad
import AOP.Internal.OpenApp
import AOP.Internal.Function
import AOP.Internal.AOTType

-- A monad that does top-level deploy/undeploy
class (Typeable1Monad m, OpenApp (->) m, OpenApp Function m) => AOPMonad m where
      deploy   :: LessGen t1 (a -> m b) => Aspect m t1 (a -> m b) -> m ()
      undeploy :: LessGen t1 t2 => Aspect m t1 t2 -> m ()


-- A MonadDeploy monad defines how to deploy and undeploy aspects
class (Monad m) => MonadDeploy m where
      deployInEnv   :: LessGen t1 (a -> AOT m b) => Aspect (AOT m) t1 (a -> AOT m b) -> 
                       AspectEnv (AOT m) -> m (AspectEnv (AOT m))
      undeployInEnv :: LessGen t1 t2 => Aspect (AOT m) t1 t2 -> 
                       AspectEnv (AOT m) -> m (AspectEnv (AOT m))
