{-# LANGUAGE ExistentialQuantification,
             ScopedTypeVariables,
             FlexibleContexts,
             DeriveDataTypeable,
             RankNTypes,
             ImpredicativeTypes,
             TypeSynonymInstances,
             FlexibleInstances
 #-}

module AOP.Internal.Aspect ( 
 Aspect (..),
 EAspect (..),
 AspectEnv,
 AspectHandle,
 deleteAsp
) where

import AOP.Internal.Pointcut
import AOP.Internal.Advice
import AOP.Internal.PolyTypeable
import AOP.Internal.LessGen
import Data.Unique


import Data.Typeable

type AspectHandle = Unique

-- Typed first-class aspect
-- An aspect is tagged with a Unique value, used for identity
data Aspect m t1 t2 = LessGen t1 t2 => Aspect (PC m t1) (Advice t2) AspectHandle 

-- Aspect with hidden types, to be used in the aspect environment
data EAspect m = forall t1 t2. LessGen t1 t2 => EAspect (Aspect m t1 t2)

-- Aspect environment
type AspectEnv m = [EAspect m]

-- Deletes asp from the aspect environment, used in undeploy
deleteAsp :: Monad m => EAspect m -> AspectEnv m -> AspectEnv m
deleteAsp asp = filter (\asp' -> asp /= asp')

-- Support por PolyTypeable
instance PolyTypeable Unique where
         polyTypeOf _ = mkTyConApp (mkTyCon3 "GHC" "Unique" "") []

-- Notion of aspect equality to delete aspects from the aspect environment
instance Monad m => Eq (EAspect m) where
         EAspect (Aspect _ _ u1) == EAspect (Aspect _ _ u2) = u1 == u2

