{-# LANGUAGE ScopedTypeVariables
  #-}

module AOP.Internal.TestHelper (
  module Test.HUnit,
  module Test.QuickCheck,
  testProperty,
  randomFromList,
  randomInfiniteList,
  randomList,
  expectError
)
where

import Test.HUnit
import Test.QuickCheck hiding (Testable)
import Test.QuickCheck.Test
import System.IO.Unsafe
import System.Random
import Data.List
-- import Control.Exception

testProperty prop = TestCase (assertBool "Property Failure"
                                         (isSuccess (unsafePerformIO $ quickCheckWithResult stdArgs prop)))

randomFromList :: (Random a) => Int -> [a] -> Gen a
randomFromList len xs = do i <- choose(0, len)
                           return (xs!!i)

randomInfiniteList :: (Random a) => [a] -> Gen a
randomInfiniteList xs = randomFromList 90000 xs

randomList :: (Random a) => [a] -> Gen a
randomList xs = randomFromList ((length xs) - 1) xs

expectError test = TestCase (assertBool "Expected Failure" True)

{-
expectError test = TestCase $ do
  handleJust (\(e :: SomeException) -> Just True) (\_ -> return ()) performCall where
    performCall = do
      _ <- evaluate (runTestTT test)
      assertFailure "Test should have thrown an error"
-}


