{-# LANGUAGE ScopedTypeVariables,
             FlexibleContexts

  #-}

import AOP.ExecutionLevels
import AOP.Internal.TestHelper
import Debug.Trace

main :: IO Counts
main = runELTTests

-- Tests
testELT1 = TestLabel "Case 1"
                     (TestCase (assertEqual "Case 1" (runProgEL program) "no loop"))

-- Test Suite
runELTTests =
         let tests = TestList [testELT1]
         in runTestTT tests

--------------------------------------------------------------------------------
  
type M = AOT (ELT Identity)

runProgEL c = runIdentity (runELT (runAOT c) 0)

showTag = newTag

showM ::  Show a => Function a (M String)
showM = mkFunction (\a -> return (show a)) showTag

logAdv :: (Show a, Show b) => Advice (a -> M b)
logAdv proceed a = do argStr <- showM # a
                      result <- proceed a
                      resStr <- showM # result
                      trace ("Arg: " ++ argStr ++ " Result: " ++ resStr)
                            (return result)

program = do deploy logAspect
             showM # (1 :: Int)
             return "no loop"
             
 where logAspect = aspect (pcCall (showM :: Function Int (M String))) logAdv




