#!/bin/bash

rm AOTTests
rm NIAOTTests
rm ELTTests
rm MacroTests

echo "===================================="
echo "Compiling AOT Tests"
echo "===================================="
ghc --make -O AOP/Test/AOTTests.hs -o AOTTests

echo "===================================="
echo "Compiling NIAOT Tests"
echo "===================================="
ghc --make -O AOP/Test/NIAOTTest.hs -o NIAOTTests


echo "===================================="
echo "Compiling ELT Tests"
echo "===================================="
ghc --make -O AOP/Test/ELTTests.hs -o ELTTests

echo "===================================="
echo "Compiling Template Haskell macro tests"
echo "===================================="
ghc --make -O AOP/Test/TestMacros.hs -o MacroTests

rm *.hi
rm *.o
rm AOP/Test/*.hi
rm AOP/Test/*.o

echo "===================================="
echo "Running AOT Tests"
./AOTTests
echo "===================================="

echo "===================================="
echo "Running NIAOT Tests"
./NIAOTTests
echo "===================================="

echo "===================================="
echo "Running ELT Tests"
./ELTTests
echo "===================================="

echo "===================================="
echo "Running Template Haskell macro tests"
./MacroTests
echo "===================================="


